diff -ru extract/pidgin-2.10.11/libpurple/prpl.h libpurple/prpl.h
--- extract/pidgin-2.10.11/libpurple/prpl.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/prpl.h	2015-03-20 00:15:22.000000000 -0400
@@ -72,7 +72,6 @@
 #include "conversation.h"
 #include "ft.h"
 #include "imgstore.h"
-#include "media.h"
 #include "notify.h"
 #include "proxy.h"
 #include "plugin.h"
@@ -80,7 +79,6 @@
 #include "status.h"
 #include "whiteboard.h"
 
-
 /** @copydoc PurpleBuddyIconSpec */
 struct _PurpleBuddyIconSpec {
 	/** This is a comma-delimited list of image formats or @c NULL if icons
Only in libpurple: purple-prefs.js
diff -ru extract/pidgin-2.10.11/libpurple/request.c libpurple/request.c
--- extract/pidgin-2.10.11/libpurple/request.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/request.c	2015-03-19 23:21:15.000000000 -0400
@@ -1196,6 +1196,11 @@
 
 /* -- */
 
+#define PURPLE_REQUEST_NO_OPS(type, title, description)		    \
+	purple_debug_error("request", "Requesting "type": %s (%s)", \
+			   title ? title : "(null)",		    \
+			   description ? description : "(null)")
+
 void *
 purple_request_input(void *handle, const char *title, const char *primary,
 				   const char *secondary, const char *default_value,
@@ -1230,6 +1235,8 @@
 
 		return info->ui_handle;
 	}
+	else
+		PURPLE_REQUEST_NO_OPS("input", title, primary);
 
 	return NULL;
 }
@@ -1292,6 +1299,8 @@
 
 		return info->ui_handle;
 	}
+	else
+		PURPLE_REQUEST_NO_OPS("choice", title, primary);
 
 	return NULL;
 }
@@ -1366,6 +1375,8 @@
 
 		return info->ui_handle;
 	}
+	else
+		PURPLE_REQUEST_NO_OPS("action", title, primary);
 
 	return NULL;
 }
@@ -1470,6 +1481,8 @@
 		handles = g_list_append(handles, info);
 		return info->ui_handle;
 	}
+	else
+		PURPLE_REQUEST_NO_OPS("file", title, filename);
 
 	return NULL;
 }
@@ -1497,6 +1510,8 @@
 		handles = g_list_append(handles, info);
 		return info->ui_handle;
 	}
+	else
+		PURPLE_REQUEST_NO_OPS("folder", title, dirname);
 
 	return NULL;
 }
diff -ru extract/pidgin-2.10.11/libpurple/server.c libpurple/server.c
--- extract/pidgin-2.10.11/libpurple/server.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/server.c	2015-03-19 23:21:15.000000000 -0400
@@ -126,7 +126,6 @@
 	PurplePlugin *prpl = NULL;
 	PurplePluginProtocolInfo *prpl_info = NULL;
 	int val = -EINVAL;
-	const gchar *auto_reply_pref = NULL;
 
 	g_return_val_if_fail(gc != NULL, val);
 
@@ -148,10 +147,9 @@
 	 * XXX - If "only auto-reply when away & idle" is set, then shouldn't
 	 * this only reset lar->sent if we're away AND idle?
 	 */
-	auto_reply_pref = purple_prefs_get_string("/purple/away/auto_reply");
 	if((gc->flags & PURPLE_CONNECTION_AUTO_RESP) &&
 			!purple_presence_is_available(presence) &&
-			!purple_strequal(auto_reply_pref, "never")) {
+			!purple_strequal(purple_prefs_get_string("/purple/away/auto_reply"), "never")) {
 
 		struct last_auto_response *lar;
 		lar = get_last_auto_response(gc, name);
@@ -645,8 +643,6 @@
 		const char *away_msg = NULL;
 		gboolean mobile = FALSE;
 
-		auto_reply_pref = purple_prefs_get_string("/purple/away/auto_reply");
-
 		presence = purple_account_get_presence(account);
 		status = purple_presence_get_active_status(presence);
 		status_type = purple_status_get_type(status);
@@ -655,7 +651,7 @@
 		if ((primitive == PURPLE_STATUS_AVAILABLE) ||
 			(primitive == PURPLE_STATUS_INVISIBLE) ||
 			mobile ||
-		    purple_strequal(auto_reply_pref, "never") ||
+		    purple_strequal((auto_reply_pref = purple_prefs_get_string("/purple/away/auto_reply")), "never") ||
 		    (!purple_presence_is_idle(presence) && purple_strequal(auto_reply_pref, "awayidle")))
 		{
 			g_free(name);
diff -ru extract/pidgin-2.10.11/libpurple/smiley.c libpurple/smiley.c
--- extract/pidgin-2.10.11/libpurple/smiley.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/smiley.c	2015-03-19 23:21:15.000000000 -0400
@@ -60,7 +60,7 @@
 static char *smileys_dir = NULL;
 
 #define SMILEYS_DEFAULT_FOLDER			"custom_smiley"
-#define SMILEYS_LOG_ID				"smileys"
+#define SMILEYS_LOG_ID				N_("smileys")
 
 #define XML_FILE_NAME				"smileys.xml"
 
diff -ru extract/pidgin-2.10.11/libpurple/ssl-nss.c libpurple/ssl-nss.c
--- extract/pidgin-2.10.11/libpurple/ssl-nss.c	2014-11-23 11:41:25.000000000 -0500
+++ libpurple/ssl-nss.c	2015-03-20 00:15:22.000000000 -0400
@@ -21,7 +21,6 @@
  */
 #include "internal.h"
 #include "debug.h"
-#include "certificate.h"
 #include "plugin.h"
 #include "sslconn.h"
 #include "util.h"
@@ -73,9 +72,9 @@
 
 #define PURPLE_SSL_NSS_DATA(gsc) ((PurpleSslNssData *)gsc->private_data)
 
-static const PRIOMethods *_nss_methods = NULL;
-static PRDescIdentity _identity;
-static PurpleCertificateScheme x509_nss;
+/* static const PRIOMethods *_nss_methods = NULL; */
+/* static PRDescIdentity _identity; */
+/* static PurpleCertificateScheme x509_nss; */
 
 /* Thank you, Evolution */
 static void
@@ -226,6 +225,7 @@
 static void
 ssl_nss_init_nss(void)
 {
+#if 0
 #if NSS_VMAJOR > 3 || ( NSS_VMAJOR == 3 && NSS_VMINOR >= 14 )
 	SSLVersionRange supported, enabled;
 #endif /* NSS >= 3.14 */
@@ -268,6 +268,7 @@
 
 	_identity = PR_GetUniqueIdentity("Purple");
 	_nss_methods = PR_GetDefaultIOMethods();
+#endif
 
 }
 
@@ -300,12 +301,15 @@
 static void
 ssl_nss_uninit(void)
 {
+#if 0
 	NSS_Shutdown();
 	PR_Cleanup();
 
 	_nss_methods = NULL;
+#endif
 }
 
+#if 0
 static void
 ssl_nss_verified_cb(PurpleCertificateVerificationStatus st,
 		       gpointer userdata)
@@ -382,6 +386,7 @@
 
 	return peer_certs;
 }
+#endif
 
 /*
  * Ideally this information would be exposed to the UI somehow, but for now we
@@ -455,6 +460,9 @@
 	purple_input_remove(nss_data->handshake_handler);
 	nss_data->handshake_handler = 0;
 
+	gsc->connect_cb(gsc->connect_cb_data, gsc, cond);
+
+#if 0
 	/* If a Verifier was given, hand control over to it */
 	if (gsc->verifier) {
 		GList *peers;
@@ -477,6 +485,7 @@
 		 */
 		gsc->connect_cb(gsc->connect_cb_data, gsc, cond);
 	}
+#endif
 }
 
 static gboolean
@@ -538,10 +547,11 @@
 
 	SSL_OptionSet(nss_data->in, SSL_SECURITY,            PR_TRUE);
 	SSL_OptionSet(nss_data->in, SSL_HANDSHAKE_AS_CLIENT, PR_TRUE);
+	SSL_OptionSet(nss_data->in, SSL_ENABLE_SESSION_TICKETS, PR_FALSE);
 
 	/* If we have our internal verifier set up, use it. Otherwise,
 	 * use default. */
-	if (gsc->verifier != NULL)
+	if (gsc->verifier != NULL && !purple_prefs_get_bool("/purple/ssl/check_certificates"))
 		SSL_AuthCertificateHook(nss_data->in, ssl_auth_cert, NULL);
 
 	if(gsc->host)
@@ -593,6 +603,11 @@
 	PRInt32 ret;
 	PurpleSslNssData *nss_data = PURPLE_SSL_NSS_DATA(gsc);
 
+	if (nss_data->handshake_handler != 0) {
+		purple_debug_error("nss", "attempting to read from an ssl socket before the end of the handshake\n");
+		return -1;
+	}
+
 	ret = PR_Read(nss_data->in, data, len);
 
 	if (ret == -1)
@@ -610,6 +625,11 @@
 	if(!nss_data)
 		return 0;
 
+	if (nss_data->handshake_handler != 0) {
+		purple_debug_error("nss", "attempting to write to an ssl socket before the end of the handshake\n");
+		return -1;
+	}
+
 	ret = PR_Write(nss_data->in, data, len);
 
 	if (ret == -1)
@@ -642,6 +662,9 @@
 	return NULL;
 }
 
+#if 0
+/* No purple_certificate_* stuff for Instantbird */
+
 /************************************************************************/
 /* X.509 functionality                                                  */
 /************************************************************************/
@@ -1213,6 +1236,7 @@
 	x509_verify_cert,                /* Verify that the specified cert chain is trusted */
 	NULL
 };
+#endif
 
 static PurpleSslOps ssl_ops =
 {
@@ -1231,6 +1255,13 @@
 };
 
 
+void purple_nss_init(void)
+{
+	purple_ssl_set_ops(&ssl_ops);
+}
+
+#if 0
+/* Instantbird does not need the plugin stuff for NSS */
 static gboolean
 plugin_load(PurplePlugin *plugin)
 {
@@ -1303,3 +1334,4 @@
 }
 
 PURPLE_INIT_PLUGIN(ssl_nss, init_plugin, info)
+#endif
diff -ru extract/pidgin-2.10.11/libpurple/sslconn.c libpurple/sslconn.c
--- extract/pidgin-2.10.11/libpurple/sslconn.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/sslconn.c	2015-03-19 23:21:15.000000000 -0400
@@ -27,11 +27,12 @@
 
 #include "internal.h"
 
-#include "certificate.h"
 #include "debug.h"
 #include "request.h"
 #include "sslconn.h"
 
+extern void purple_nss_init(void);
+
 static gboolean _ssl_initialized = FALSE;
 static PurpleSslOps *_ssl_ops = NULL;
 
@@ -43,11 +44,14 @@
 
 	if (_ssl_initialized)
 		return FALSE;
+#if 0
 
 	plugin = purple_plugins_find_with_id("core-ssl");
 
 	if (plugin != NULL && !purple_plugin_is_loaded(plugin))
 		purple_plugin_load(plugin);
+#endif
+	purple_nss_init();
 
 	ops = purple_ssl_get_ops();
 	if ((ops == NULL) || (ops->init == NULL) || (ops->uninit == NULL) ||
@@ -63,12 +67,8 @@
 gboolean
 purple_ssl_is_supported(void)
 {
-#ifdef HAVE_SSL
 	ssl_init();
 	return (purple_ssl_get_ops() != NULL);
-#else
-	return FALSE;
-#endif
 }
 
 static void
@@ -131,8 +131,10 @@
 	gsc->connect_cb      = func;
 	gsc->error_cb        = error_func;
 
+#if 0
 	/* TODO: Move this elsewhere */
 	gsc->verifier = purple_certificate_find_verifier("x509","tls_cached");
+#endif
 
 	gsc->connect_data = purple_proxy_connect(NULL, account, host, port, purple_ssl_connect_cb, gsc);
 
@@ -222,8 +224,10 @@
     if(host)
         gsc->host            = g_strdup(host);
 
+#if 0
 	/* TODO: Move this elsewhere */
 	gsc->verifier = purple_certificate_find_verifier("x509","tls_cached");
+#endif
 
 
 	ops = purple_ssl_get_ops();
diff -ru extract/pidgin-2.10.11/libpurple/sslconn.h libpurple/sslconn.h
--- extract/pidgin-2.10.11/libpurple/sslconn.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/sslconn.h	2015-03-19 23:21:15.000000000 -0400
@@ -34,13 +34,13 @@
 	PURPLE_SSL_CERTIFICATE_INVALID = 3
 } PurpleSslErrorType;
 
-#include "certificate.h"
 #include "proxy.h"
 
 #define PURPLE_SSL_DEFAULT_PORT 443
 
 /** @copydoc _PurpleSslConnection */
 typedef struct _PurpleSslConnection PurpleSslConnection;
+typedef struct _PurpleCertificateVerifier PurpleCertificateVerifier;
 
 typedef void (*PurpleSslInputFunction)(gpointer, PurpleSslConnection *,
 									 PurpleInputCondition);
diff -ru extract/pidgin-2.10.11/libpurple/status.c libpurple/status.c
--- extract/pidgin-2.10.11/libpurple/status.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/status.c	2015-03-19 23:21:15.000000000 -0400
@@ -607,6 +607,7 @@
 notify_buddy_status_update(PurpleBuddy *buddy, PurplePresence *presence,
 		PurpleStatus *old_status, PurpleStatus *new_status)
 {
+#if 0
 	if (purple_prefs_get_bool("/purple/logging/log_system"))
 	{
 		time_t current_time = time(NULL);
@@ -652,6 +653,7 @@
 		g_free(tmp);
 		g_free(logtmp);
 	}
+#endif
 }
 
 static void
@@ -1253,6 +1255,7 @@
 	PurpleBlistUiOps *ops = purple_blist_get_ui_ops();
 	PurpleAccount *account = purple_buddy_get_account(buddy);
 
+#if 0
 	if (!old_idle && idle)
 	{
 		if (purple_prefs_get_bool("/purple/logging/log_system"))
@@ -1293,6 +1296,7 @@
 			}
 		}
 	}
+#endif
 
 	if (old_idle != idle)
 		purple_signal_emit(purple_blist_get_handle(), "buddy-idle-changed", buddy,
@@ -1339,6 +1343,7 @@
 
 		account = purple_presence_get_account(presence);
 
+#if 0
 		if (purple_prefs_get_bool("/purple/logging/log_system"))
 		{
 			PurpleLog *log = purple_account_get_log(account, FALSE);
@@ -1360,6 +1365,7 @@
 				g_free(msg);
 			}
 		}
+#endif
 
 		gc = purple_account_get_connection(account);
 
diff -ru extract/pidgin-2.10.11/libpurple/upnp.h libpurple/upnp.h
--- extract/pidgin-2.10.11/libpurple/upnp.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/upnp.h	2015-03-19 23:21:15.000000000 -0400
@@ -61,17 +61,6 @@
  */
 void purple_upnp_discover(PurpleUPnPCallback cb, gpointer cb_data);
 
-#if 0
-/**
- * Retrieve the current UPnP control info, if there is any available.
- * This will only be filled in if purple_upnp_discover() had been called,
- * and finished discovering.
- *
- * @return The control URL for the IGD we'll use to use the IGD services
- */
-const PurpleUPnPControlInfo* purple_upnp_get_control_info(void);
-#endif
-
 /**
  * Gets the IP address from a UPnP enabled IGD that sits on the local
  * network, so when getting the network IP, instead of returning the
diff -ru extract/pidgin-2.10.11/libpurple/util.c libpurple/util.c
--- extract/pidgin-2.10.11/libpurple/util.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/util.c	2015-03-20 00:15:22.000000000 -0400
@@ -2497,6 +2497,7 @@
 /**************************************************************************
  * Path/Filename Functions
  **************************************************************************/
+#ifdef PURPLE_PLUGINS
 const char *
 purple_home_dir(void)
 {
@@ -2506,17 +2507,14 @@
 	return wpurple_data_dir();
 #endif
 }
+#endif
 
 /* Returns the argument passed to -c IFF it was present, or ~/.purple. */
 const char *
 purple_user_dir(void)
 {
-	if (custom_user_dir != NULL)
-		return custom_user_dir;
-	else if (!user_dir)
-		user_dir = g_build_filename(purple_home_dir(), ".purple", NULL);
-
-	return user_dir;
+	g_return_val_if_fail(custom_user_dir != NULL, NULL);
+	return custom_user_dir;
 }
 
 void purple_util_set_user_dir(const char *dir)
@@ -2730,6 +2728,7 @@
 	return xmlnode_from_file(purple_user_dir(), filename, description, "util");
 }
 
+#if 0
 /*
  * Like mkstemp() but returns a file pointer, uses a pre-set template,
  * uses the semantics of tempnam() for the directory to use and allocates
@@ -2778,6 +2777,7 @@
 
 	return fp;
 }
+#endif
 
 const char *
 purple_util_get_image_extension(gconstpointer data, size_t len)
@@ -2845,6 +2845,7 @@
 	return filename;
 }
 
+#if 0
 gboolean
 purple_program_is_valid(const char *program)
 {
@@ -2880,12 +2881,12 @@
 
 	return is_valid;
 }
-
+#endif
 
 gboolean
 purple_running_gnome(void)
 {
-#ifndef _WIN32
+#if !defined(_WIN32) && !defined(__APPLE__)
 	gchar *tmp = g_find_program_in_path("gnome-open");
 
 	if (tmp == NULL)
@@ -2903,7 +2904,7 @@
 gboolean
 purple_running_kde(void)
 {
-#ifndef _WIN32
+#if !defined(_WIN32) && !defined(__APPLE__)
 	gchar *tmp = g_find_program_in_path("kfmclient");
 	const char *session;
 
diff -ru extract/pidgin-2.10.11/libpurple/util.h libpurple/util.h
--- extract/pidgin-2.10.11/libpurple/util.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/util.h	2015-03-19 23:21:15.000000000 -0400
@@ -644,7 +644,7 @@
  *
  * @see purple_user_dir()
  */
-const gchar *purple_home_dir(void);
+/* const gchar *purple_home_dir(void); */
 
 /**
  * Returns the purple settings directory in the user's home directory.
@@ -745,7 +745,7 @@
  *
  * @return A file pointer to the temporary file, or @c NULL on failure.
  */
-FILE *purple_mkstemp(char **path, gboolean binary);
+/* FILE *purple_mkstemp(char **path, gboolean binary); */
 
 /**
  * Returns an extension corresponding to the image data's file type.
@@ -787,7 +787,7 @@
  *
  * @return TRUE if the program is runable.
  */
-gboolean purple_program_is_valid(const char *program);
+/* gboolean purple_program_is_valid(const char *program); */
 
 /**
  * Check if running GNOME.
Only in libpurple: version.h
diff -ru extract/pidgin-2.10.11/libpurple/win32/libc_interface.h libpurple/win32/libc_interface.h
--- extract/pidgin-2.10.11/libpurple/win32/libc_interface.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/win32/libc_interface.h	2015-03-19 23:21:15.000000000 -0400
@@ -134,8 +134,6 @@
 /* stdio.h */
 #undef snprintf
 #define snprintf _snprintf
-#undef vsnprintf
-#define vsnprintf _vsnprintf
 
 #define rename( oldname, newname ) \
 wpurple_rename( oldname, newname )
diff -ru extract/pidgin-2.10.11/libpurple/win32/win32dep.c libpurple/win32/win32dep.c
--- extract/pidgin-2.10.11/libpurple/win32/win32dep.c	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/win32/win32dep.c	2015-03-19 23:21:15.000000000 -0400
@@ -22,7 +22,10 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111-1301  USA
  *
  */
+#ifndef _WIN32_IE
 #define _WIN32_IE 0x501
+#endif
+
 #include "internal.h"
 #include <winuser.h>
 
@@ -112,6 +115,7 @@
 
 /* Determine Purple Paths during Runtime */
 
+#if 0
 /* Get paths to special Windows folders. */
 gchar *wpurple_get_special_folder(int folder_type) {
 	gchar *retval = NULL;
@@ -327,6 +331,7 @@
 
 	return result;
 }
+#endif
 
 void wpurple_init(void) {
 	WORD wVersionRequested;
@@ -336,7 +341,7 @@
 		g_thread_init(NULL);
 
 	purple_debug_info("wpurple", "wpurple_init start\n");
-	purple_debug_info("wpurple", "libpurple version: " DISPLAY_VERSION "\n");
+	//	purple_debug_info("wpurple", "libpurple version: " DISPLAY_VERSION "\n");
 
 	purple_debug_info("wpurple", "Glib:%u.%u.%u\n",
 		glib_major_version, glib_minor_version, glib_micro_version);
diff -ru extract/pidgin-2.10.11/libpurple/win32/win32dep.h libpurple/win32/win32dep.h
--- extract/pidgin-2.10.11/libpurple/win32/win32dep.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/win32/win32dep.h	2015-03-19 23:21:15.000000000 -0400
@@ -54,18 +54,17 @@
  **/
 /* Windows helper functions */
 FARPROC wpurple_find_and_loadproc(const char *dllname, const char *procedure);
-gboolean wpurple_read_reg_dword(HKEY rootkey, const char *subkey, const char *valname, LPDWORD result);
-char *wpurple_read_reg_string(HKEY rootkey, const char *subkey, const char *valname); /* needs to be g_free'd */
-gboolean wpurple_write_reg_string(HKEY rootkey, const char *subkey, const char *valname, const char *value);
+/* gboolean wpurple_read_reg_dword(HKEY rootkey, const char *subkey, const char *valname, LPDWORD result); */
+/* char *wpurple_read_reg_string(HKEY rootkey, const char *subkey, const char *valname); / * needs to be g_free'd */
+/* gboolean wpurple_write_reg_string(HKEY rootkey, const char *subkey, const char *valname, const char *value); */
 char *wpurple_escape_dirsep(const char *filename); /* needs to be g_free'd */
-GIOChannel *wpurple_g_io_channel_win32_new_socket(int socket); /* Until we get the post-2.8 glib win32 giochannel implementation working, use the thread-based one */
 
 /* Determine Purple paths */
-gchar *wpurple_get_special_folder(int folder_type); /* needs to be g_free'd */
-const char *wpurple_install_dir(void);
-const char *wpurple_lib_dir(void);
-const char *wpurple_locale_dir(void);
-const char *wpurple_data_dir(void);
+/* gchar *wpurple_get_special_folder(int folder_type); /* needs to be g_free'd */
+/* const char *wpurple_install_dir(void); */
+/* const char *wpurple_lib_dir(void); */
+/* const char *wpurple_locale_dir(void); */
+/* const char *wpurple_data_dir(void); */
 
 /* init / cleanup */
 void wpurple_init(void);
@@ -80,9 +79,9 @@
 /*
  *  Purple specific
  */
-#define DATADIR wpurple_install_dir()
-#define LIBDIR wpurple_lib_dir()
-#define LOCALEDIR wpurple_locale_dir()
+/* #define DATADIR wpurple_install_dir() */
+/* #define LIBDIR wpurple_lib_dir() */
+/* #define LOCALEDIR wpurple_locale_dir() */
 
 #ifdef __cplusplus
 }
diff -ru extract/pidgin-2.10.11/libpurple/win32/wpurpleerror.h libpurple/win32/wpurpleerror.h
--- extract/pidgin-2.10.11/libpurple/win32/wpurpleerror.h	2014-11-23 11:41:26.000000000 -0500
+++ libpurple/win32/wpurpleerror.h	2015-03-20 00:15:22.000000000 -0400
@@ -25,6 +25,16 @@
 #ifndef _WPURPLEERROR_H
 #define _WPURPLEERROR_H
 
+#if defined(_MSC_VER) && _MSC_VER >= 1600
+/* libpurple expects errno to contain winsocks error codes rather than
+   the real errno values (which are defined in MSVC10). */
+
+/* Include the Microsoft errno.h before undefining the error codes, so
+   that it doesn't do anything if it is included later (avoid macro
+   redefinition warnings). */
+#include <errno.h>
+#endif
+
 /* Here we define unix socket errors as windows socket errors */
 
 #undef ENETDOWN
@@ -44,8 +54,6 @@
 
 #undef EADDRINUSE
 #define EADDRINUSE WSAEADDRINUSE
-#undef EINPROGRESS
-#define EINPROGRESS WSAEINPROGRESS
 #undef EALREADY
 #define EALREADY WSAEALREADY
 #undef EADDRNOTAVAIL
